<?php

// Allow PHP API.
header('Access-Control-Allow-Origin: *');

header('Content-Type: application/json');

header("Access-Control-Allow-Methods: GET, POST, OPTIONS, PUT, DELETE");

header("Allow: GET, POST, OPTIONS, PUT, DELETE");

header("Access-Control-Allow-Headers: X-API-KEY, Origin, X-Requested-With, Content-Type, Accept, Access-Control-Request-Method, Access-Control-Allow-Origin");

if ($_SERVER['REQUEST_METHOD'] == "POST") {
    $data = file_get_contents('php://input');
    $data = json_decode($data, true);
    require_once "database.php";
    $objData = new db();

    function getCount($tablename, $coon)
    {
        $count = $coon->getData('select count(*) as len from ' . $tablename);
        $count = $count[0]['len'];
        return intval($count);
    }

    if ($data['event_type'] === 'UpdateAccounts') {
        foreach ($data['accounts'] as $item) {
            $ac = $objData->getData('SELECT acc_id FROM scalpers_accounts WHERE acc_id=' . $item['acc_id']);
            if (count($ac) == 0) {
                $objData->execData(
                    "INSERT INTO scalpers_accounts (acc_id,acc_name, api_id) VALUES (?,?, ?)",
                    [
                        $item['acc_id'],
                        $item['acc_name'],
                        $item['api_id']
                    ]
                );
            } else {
                $objData->execData(
                    "UPDATE scalpers_accounts SET acc_name=?,api_id=? WHERE acc_id=?",
                    [
                        $item['acc_name'],
                        $item['api_id'],
                        $item['acc_id']
                    ]
                );
            }
        }
        echo json_encode(array(
            "message" => "Added accounts successfuly.!",
            "data" => [],
            "status" => true
        ));
    }

    if ($data['event_type'] === 'getAccounts') {
        $limit_from = $data['limit_from'];
        $limit_to = $data['limit_to'];
        $accounts = $objData->getData('select * from scalpers_accounts ' . ' limit ' . $limit_from . ',' . $limit_to);
        echo json_encode(array(
            "message" => "",
            "data" => array(
                "accounts" => $accounts,
                "len" => getCount('scalpers_accounts', $objData)
            ),
            "status" => true
        ));
    }

    if ($data['event_type'] === 'getAccount') {
        $account = $objData->getData('select * from scalpers_accounts where acc_id=' . $data['id']);
        echo json_encode(array(
            "message" => "",
            "data" => $account[0],
            "status" => true
        ));
    }

    if ($data['event_type'] === 'UpdateAccount') {
        $up_acc = $objData->execData(
            "UPDATE scalpers_accounts SET acc_name=?,acc_type=?,acc_status=?,acc_title=? WHERE acc_id=?",
            [
                $data['acc_name'],
                $data['acc_type'],
                $data['acc_status'],
                $data['acc_title'],
                $data['acc_id']
            ]
        );
        if ($up_acc) {
            echo json_encode(array(
                "message" => "Updated account successfuly.!",
                "data" => [],
                "status" => true
            ));
        } else {
            echo json_encode(array(
                "message" => "Can't update account.!",
                "data" => [],
                "status" => false
            ));
        }
    }
    if($data['event_type'] === 'UpdateDealsGroup')
    {
        // add deals to group
        foreach($data['deals'] as $item)
        {
            $deal = $objData->getData("SELECT * FROM scalpers_deals_group WHERE deal_id=" . $item['id']);
            if(count($deal) === 0)
            {
                $objData->execData("INSERT INTO scalpers_deals_group (deal_id,deal_state,deal_group_id,api_id) VALUES(?,?,?,?)",
                [
                    $item['id'],
                    1,
                    $data['group_id'],
                    $data['api_id']
                ]);
            }
        }
        $deals = $objData->getData("SELECT * FROM scalpers_deals_group");
        echo json_encode(array(
            "message" => "Updated account successfuly.!",
            "data" => $deals,
            "status" => true
        ));
    }
    if($data['event_type'] === 'UpdateDealGroup')
    {
        $objData->execData("UPDATE scalpers_deals_group SET deal_state=? WHERE deal_id=?",
            [
                $data['deal_state'],
                $data['id'],
            ]
        );
        echo json_encode(array(
            "message" => "Updated account successfuly.!",
            "data" => [],
            "status" => true
        ));
    }
    if($data['event_type'] === 'UpdateAccountCondition')
    {
        $objData->execData("UPDATE scalpers_accounts SET cond_str=?,cond_value=? WHERE acc_id=?",
            [
                $data['cond_str'],
                $data['cond_value'],
                $data['acc_id']
            ]
        );
        echo json_encode(array(
            "message" => "Updated account successfuly.!",
            "data" => [],
            "status" => true
        ));
    }
    if($data['event_type'] === 'getRequisites')
    {
        $reqs = $objData->getData("SELECT * FROM scalpers_deals_requests as reqs,scalpers_users as users WHERE users.user_id=reqs.req_user_id");
        echo json_encode(array(
            "message" => "",
            "data" => $reqs,
            "status" => true
        ));
    }
    if($data['event_type'] === 'CancelRequest')
    {
        $objData->execData("DELETE FROM scalpers_deals_requests WHERE deal_id=?", [
            $data['id']
        ]);
        echo json_encode(array(
            "message" => "Deleted requiest successfuly.!",
            "data" => [],
            "status" => true
        ));
    }
    if($data['event_type'] === 'getDealsGroup')
    {
        $deals = $objData->getData("SELECT * FROM scalpers_deals_group");
        $newR = [];
        foreach($deals as $item)
        {
            $deals_temp = $objData->getData(
                "SELECT * FROM scalpers_temp_deals as a WHERE a.deal_id=" . $item['deal_id']
            );
            $deals_reqs = $objData->getData(
                "SELECT * FROM scalpers_deals_requests as b WHERE b.req_deal_id=" . $item['deal_id']
            );
            if(count($deals_temp) === 0 && count($deals_reqs) === 0)
            {
                $acc = $objData->getData("SELECT * FROM scalpers_accounts WHERE cat_id='' and user_id='' and acc_id=" . $item['deal_group_id']);
                if($acc)
                {
                    array_push($newR, $item);
                }
            }
        }
        echo json_encode(array(
            "message" => "",
            "data" => $newR,
            "status" => true
        ));
    }
    
    if($data['event_type'] === 'getDealsGroupByID')
    {
        $deals = [];
        if($data['type'] === 'user')
        {
            $deals = $objData->getData("SELECT * FROM scalpers_deals_group as a,scalpers_accounts as b WHERE a.deal_group_id=b.acc_id AND b.user_id=" .intval($data['id']));
        }
        
        if($data['type'] === 'category')
        {
            $deals = $objData->getData("SELECT * FROM scalpers_deals_group as a,scalpers_accounts as b WHERE a.deal_group_id=b.acc_id AND b.cat_id=" .intval($data['id']));
        }
        
        $newR = [];
        foreach($deals as $item)
        {
            $deals_temp = $objData->getData(
                "SELECT * FROM scalpers_temp_deals as a WHERE a.deal_id=" . $item['deal_id']
            );
            $deals_reqs = $objData->getData(
                "SELECT * FROM scalpers_deals_requests as b WHERE b.req_deal_id=" . $item['deal_id']
            );
            if(count($deals_temp) === 0 && count($deals_reqs) === 0)
            {
                array_push($newR, $item);
            }
        }
        echo json_encode(array(
            "message" => "",
            "data" => $newR,
            "status" => true
        ));
    }
    
    if($data['event_type'] === 'addNewDealGroupToUser')
    {
        $objData->execData("INSERT INTO scalpers_temp_deals(user_id,bot_id,deal_id,api_id,deal_is_group)VALUES(?,?,?,?,?)", 
        [
            $data['user_id'],
            $data['bot_id'],
            $data['deal_id'],
            $data['api_id'],
            2
        ]);
        $objData->execData("DELETE FROM scalpers_deals_requests WHERE req_deal_id=?", [
            $data['deal_id']
        ]);
        echo json_encode(array(
            "message" => "Added deal successfuly.!",
            "data" => [],
            "status" => true
        ));
    }
    if($data['event_type'] === 'addNewDealToRequisites')
    {
        $objData->execData("INSERT INTO scalpers_deals_requests(req_user_id,req_deal_id,api_id,req_type)VALUES(?,?,?,?)", 
        [
            $data['user_id'],
            $data['deal_id'],
            $data['api_id'],
            2
        ]);
        echo json_encode(array(
            "message" => "Added deal successfuly.!",
            "data" => [],
            "status" => true
        ));
    }
    
    //UpdateAccountUser
    if($data['event_type'] === 'UpdateAccountCategory')
    {
        $objData->execData("UPDATE scalpers_accounts SET cat_id=?,user_id=? WHERE acc_id=?",
            [
                $data['cat_id'],
                null,
                $data['acc_id']
            ]
        );
        echo json_encode(array(
            "message" => "Updated account successfuly.!",
            "data" => [],
            "status" => true
        ));
    }
    
    if($data['event_type'] === 'UpdateAccountUser')
    {
        $objData->execData("UPDATE scalpers_accounts SET cat_id=?,user_id=? WHERE acc_id=?",
            [
                null,
                $data['user_id'],
                $data['acc_id']
            ]
        );
        echo json_encode(array(
            "message" => "Updated account successfuly.!",
            "data" => [],
            "status" => true
        ));
    }
    if($data['event_type'] === 'saveCapital')
    {
        $objData->execData("UPDATE scalpers_accounts SET acc_capital=? WHERE acc_id=?",
            [
                $data['capital'],
                $data['acc_id']
            ]
        );
        echo json_encode(array(
            "message" => "Updated account successfuly.!",
            "data" => [],
            "status" => true
        ));
    }
    
    
} else {
    header("HTTP/1.1 404 Not Found");
}
