<?php

// Allow PHP API.
header('Access-Control-Allow-Origin: *');

header('Content-Type: application/json');

header("Access-Control-Allow-Methods: GET, POST, OPTIONS, PUT, DELETE");

header("Allow: GET, POST, OPTIONS, PUT, DELETE");

header("Access-Control-Allow-Headers: X-API-KEY, Origin, X-Requested-With, Content-Type, Accept, Access-Control-Request-Method, Access-Control-Allow-Origin");


if ($_SERVER['REQUEST_METHOD'] == "POST") {

    $data = file_get_contents('php://input');
    $data = json_decode($data, true);
    require_once "database.php";
    $objData = new db();

    function getCount($tablename, $coon)
    {
        $count = $coon->getData('select count(*) as len from ' . $tablename);
        $count = $count[0]['len'];
        return intval($count);
    }
    if ($data['event_type'] === 'UpdateBots') {
        foreach ($data['bots'] as $item) {
            $ac = $objData->getData('SELECT bot_id FROM scalpers_bots WHERE bot_id=' . $item['bot_id']);
            if (count($ac) == 0) {
                $objData->execData(
                    "INSERT INTO scalpers_bots(bot_id,bot_name,active_deals_count,account_name,account_id,deal_id,strategy,pair,api_id,bot_type) VALUES (?,?,?,?,?,?,?,?,?,?)",
                    [
                        $item['bot_id'],
                        $item['bot_name'],
                        $item['active_deals_count'],
                        $item['account_name'],
                        $item['account_id'],
                        0,
                        $item['strategy'],
                        $item['pair'],
                        intval($item['api_id']),
                        $item['type']
                    ]
                );
            } else {
                $id = $ac[0]['bot_id'];
                $objData->execData(
                    "UPDATE scalpers_bots SET bot_name=?,active_deals_count=?,account_name=?,api_id=?,bot_type=? WHERE bot_id=?",
                    [
                        $item['bot_name'],
                        $item['active_deals_count'],
                        $item['account_name'],
                        $item['api_id'],
                        $item['type'],
                        $id
                    ]
                );
            }
        }
        $limit_from = intval($data['limit_from']);
        $limit_to = intval($data['limit_to']);
        $list_of_bots = $objData->getData("select * from scalpers_bots where bot_is_deleted=1 ORDER BY bot_id DESC limit " . $limit_from . ',' . $limit_to);
        echo json_encode(array(
            "message" => "Added bots successfuly.!",
            "data" => array(
                "bots" => $list_of_bots,
                "len" => getCount('scalpers_bots', $objData)
            ),
            "status" => true
        ));
    }

    if ($data['event_type'] === 'getBots') {
        $limit_from = intval($data['limit_from']);
        $limit_to = intval($data['limit_to']);
        $list_of_bots = $objData->getData("select * from scalpers_bots,scalpers_accounts where scalpers_bots.bot_is_deleted=1 and scalpers_accounts.acc_id = scalpers_bots.account_id and scalpers_accounts.acc_status = 1 and scalpers_bots.deal_id = 0 ORDER BY scalpers_bots.bot_id DESC limit " . $limit_from . ',' . $limit_to);
        $len = $objData->getData("select count(*) as len from scalpers_bots,scalpers_accounts where scalpers_bots.bot_is_deleted=1 and scalpers_accounts.acc_id = scalpers_bots.account_id and scalpers_accounts.acc_status = 1 and scalpers_bots.deal_id = 0 ORDER BY scalpers_bots.bot_id DESC");
        $len = $len[0]['len'];
        echo json_encode(array(
            "message" => "Added bots successfuly.!",
            "data" => array(
                "bots" => $list_of_bots,
                "len" => intval($len)
            ),
            "status" => true
        ));
    }

    if ($data['event_type'] === 'getBotsPairs') {
        // getting bots withiut null status...
        // user_id = -2 -> bot is null will do not view.
        $list_of_bots = $objData->getData("select * from scalpers_bots");
        $len = $objData->getData("select count(*) as len from scalpers_bots");
        $len = $len[0]['len'];
        echo json_encode(array(
            "message" => "Added bots successfuly.!",
            "data" => array(
                "bots" => $list_of_bots,
                "len" => intval($len)
            ),
            "status" => true
        ));
    }

    if ($data['event_type'] === 'getBot') {
        // getting bots withiut null status...
        // user_id = -2 -> bot is null will do not view.
        $list_of_bots = $objData->getData("select * from scalpers_bots where bot_id=" . $data['bot_id']);
        echo json_encode(array(
            "message" => "Added bots successfuly.!",
            "data" => $list_of_bots,
            "status" => true
        ));
    }

    if ($data['event_type'] === 'getFreeBots') {
        $from = $data['limit_from'];
        $to = $data['limit_to'];
        $bots = $objData->getData("SELECT * FROM scalpers_bots as b, scalpers_accounts as a WHERE b.active_deals_count=0 AND b.cat_id=-1 AND b.user_id=-1 AND a.acc_id = b.account_id AND a.acc_status=1");
        echo json_encode(array(
            "status" => true,
            "data" => array(
                "bots" => $bots,
                "len" => 0
            ),
            "message" => ""
        ));
    }
    
    if ($data['event_type'] === 'getBotsForProfit') {
        
        $result = [];
        $searchStatement = [];

        if ($data['acc_id'] != '-1') {
            array_push($searchStatement, "account_id=" . $data['acc_id']);
        }
        
        if ($data['cat_id'] != '-1') {
            array_push($searchStatement, "cat_id=" . $data['cat_id']);
        }
        
        if ($data['user_id'] != '-1') {
            array_push($searchStatement, "user_id=" . $data['user_id']);
        }


        $statmentString = implode(" AND ", $searchStatement);

        if ($statmentString !== '') {
            $result = $objData->getData("SELECT * FROM scalpers_bots  WHERE " . $statmentString);
        }


        echo json_encode(array(
            "message" => "SELECT * FROM scalpers_bots  WHERE " . $statmentString,
            "data" => $result,
            "status" => true
        ));
    }

    if ($data['event_type'] === 'addDealToBot') {
        $update_boots = $objData->execData(
            "UPDATE scalpers_bots SET active_deals_count=?,deal_id=? WHERE bot_id=?",
            [
                1,
                $data['deal_id'],
                intval($data['bot_id'])
            ]
        );
        if ($update_boots) {
            echo json_encode(array(
                "message" => "Updated successfuly.!",
                "data" => [],
                "status" => true
            ));
        } else {
            echo json_encode(array(
                "message" => "Can't updated data.!",
                "data" => [],
                "status" => false
            ));
        }
    }
    if ($data['event_type'] === 'closeDealToBot') {
        $update_boots = $objData->execData(
            "UPDATE scalpers_bots SET active_deals_count=?,deal_id=? WHERE bot_id=?",
            [
                0,
                0,
                intval($data['bot_id'])
            ]
        );
        if ($update_boots) {
            echo json_encode(array(
                "message" => "Updated successfuly.!",
                "data" => [],
                "status" => true
            ));
        } else {
            echo json_encode(array(
                "message" => "Can't updated data.!",
                "data" => [],
                "status" => false
            ));
        }
    }
    if ($data['event_type'] === 'addListOfBots') {
        $list = $data['bots'];
        foreach ($list as $item) {
            $objData->execData(
                "INSERT INTO scalpers_bots(bot_id,bot_name,active_deals_count,account_name,account_id,deal_id,strategy,pair,user_id, api_id) VALUES (?,?,?,?,?,?,?,?,?,?)",
                [
                    $item['id'],
                    $item['name'],
                    0,
                    $item['account_name'],
                    $item['account_id'],
                    0,
                    $item['strategy'],
                    $item['pair'],
                    intval($item['user_id']),
                    intval($item['api_id'])
                ]
            );
        }
        echo json_encode(array(
            "message" => "Updated successfuly.!",
            "data" => $list,
            "status" => true
        ));
    }
    if ($data['event_type'] === 'edit_boot') {
        $update_boots = $objData->execData(
            "UPDATE scalpers_bots SET bot_name=? WHERE bot_id=?",
            [
                $data['bot_name'],
                intval($data['bot_id'])
            ]
        );
        if ($update_boots) {
            echo json_encode(array(
                "message" => "Updated successfuly.!",
                "data" => [],
                "status" => true
            ));
        } else {
            echo json_encode(array(
                "message" => "Can't updated data.!",
                "data" => [],
                "status" => false
            ));
        }
    }
} else {
    header("HTTP/1.1 404 Not Found");
}