<?php

// Allow PHP API.
header('Access-Control-Allow-Origin: *');

header('Content-Type: application/json');

header("Access-Control-Allow-Methods: GET, POST, OPTIONS, PUT, DELETE");

header("Allow: GET, POST, OPTIONS, PUT, DELETE");

header("Access-Control-Allow-Headers: X-API-KEY, Origin, X-Requested-With, Content-Type, Accept, Access-Control-Request-Method, Access-Control-Allow-Origin");

if ($_SERVER['REQUEST_METHOD'] == "POST") {
    $data = file_get_contents('php://input');
    $data = json_decode($data, true);
    require_once "database.php";
    $objData = new db();

    if ($data['event_type'] == "getCategories") {
        $limit = intval($data['limit']);
        $categories = $objData->getData('select * from scalpers_categories limit ' . $limit);

        echo json_encode(array(
            "message" => "",
            "data" => $categories,
            "status" => true
        ));
    }

    if ($data['event_type'] == "getCategoryById") {
        $cat_id = intval($data['cat_id']);
        $categories = $objData->getData('select * from scalpers_categories where cat_id=' . $cat_id);
        echo json_encode(array(
            "message" => "",
            "data" => $categories[0],
            "status" => true
        ));
    }

    if ($data['event_type'] == "UpdateCategory") {
        $update_Category = $objData->execData(
            "update scalpers_categories set cat_name=?,cat_pairs_list=?,cat_levels=?,cat_is_group=? where cat_id=?",
            [
                $data["cat_name"],
                $data["cat_pairs_list"],
                $data["cat_levels"],
                $data['cat_is_group'],
                intval($data['cat_id'])
            ]
        );
        if ($update_Category) {
            echo json_encode(array(
                "message" => "Updated successfuly.!",
                "data" => [],
                "status" => true
            ));
        } else {
            echo json_encode(array(
                "message" => "Can't updated data.!",
                "data" => [],
                "status" => false
            ));
        }
    }
    if ($data['event_type'] == "UpdateCategoryBots") {
        $update_Category = $objData->execData(
            "update scalpers_categories set cat_bots_list=? where cat_id=?",
            [
                $data['cat_bots_list'],
                intval($data['cat_id'])
            ]
        );
        if ($update_Category) {
            echo json_encode(array(
                "message" => "Updated successfuly.!",
                "data" => [],
                "status" => true
            ));
        } else {
            echo json_encode(array(
                "message" => "Can't updated data.!",
                "data" => [],
                "status" => false
            ));
        }
    }
    if ($data['event_type'] == "AddCategory") {
        $update_user = $objData->execData(
            "INSERT INTO scalpers_categories (cat_name,cat_pairs_list,cat_levels,cat_bots_list,cat_is_group) VALUES (?,?,?,?,?)",
            [
                $data["cat_name"],
                $data["cat_pairs_list"],
                $data["cat_levels"],
                $data['cat_bots_list'],
                $data['cat_is_group']
            ]
        );

        if ($update_user) {
            echo json_encode(array(
                "message" => "Added successfuly.!",
                "data" => [],
                "status" => true
            ));
        } else {
            echo json_encode(array(
                "message" => "Can't Add data.!",
                "data" => [],
                "status" => false
            ));
        }
    }
    if ($data['event_type'] == 'deleteCategory') {
        $delete_cat = $objData->execData(
            "DELETE FROM scalpers_categories WHERE cat_id=?",
            [
                $data['cat_id']
            ]
        );

        if ($delete_cat) {
            echo json_encode(array(
                "message" => "Deleted successfuly.!",
                "data" => [],
                "status" => true
            ));
        } else {
            echo json_encode(array(
                "message" => "Can't Delete it.!",
                "data" => [],
                "status" => false
            ));
        }
    }
} else {
    header("HTTP/1.1 404 Not Found");
}
