<?php

// Allow PHP API.
header('Access-Control-Allow-Origin: *');
header('Content-Type: application/json');
header("Access-Control-Allow-Methods: GET, POST, OPTIONS, PUT, DELETE");
header("Allow: GET, POST, OPTIONS, PUT, DELETE");
header("Access-Control-Allow-Headers: X-API-KEY, Origin, X-Requested-With, Content-Type, Accept, Access-Control-Request-Method, Access-Control-Allow-Origin");


require_once("./PhpOffice/vendor/autoload.php");

use PhpOffice\PhpSpreadsheet\Calculation\Statistical\Distributions\F;
use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\Reader\IReader;
use PhpOffice\PhpSpreadsheet\Writer\IWriter;



class export_excel
{
	public function __construct($data)
	{
		echo $this->download([
			$this->export($data)
		]);
	}
	public function getChars($index)
	{
		$cells = [];
		$rang = range('A', 'Z');
		$c = 0;
		$j = 0;
		$chr = '';

		for ($c = 0; $c < count($rang); $c++) {
			array_push($cells, $rang[$c]);
		}
		$c = 0;
		$v = 0;
		$chr = $rang[$v];
		for ($c = 0; $c < 701; $c++) {
			if ($j < count($rang)) {
				array_push($cells, $chr . '' . $rang[$j]);
				$j++;
			} else {
				$j = 0;
				$v += 1;
				$chr = $rang[$v];
			}
		}

		return $cells[$index];
	}
	public function export($data)
	{
		require 'PhpOffice/vendor/autoload.php';
		$sheetname = $this->getDate('Y_m_d__H_t_s');
		$spreadsheet = new Spreadsheet();
		if (count($data) > 0)
			$columns = array_keys($data[0]);
		$sheet = $spreadsheet->getActiveSheet();
		$sheet->setTitle('sheet1');

		// Add some data
		$spreadsheet->createSheet();
		$i = 0;

		for ($i = 0; $i < count($columns); $i++) {
			$spreadsheet->setActiveSheetIndex(0)->setCellValue($this->getChars($i) . '1', $columns[$i]);
		}
		$i = 0;
		for ($i = 0; $i < count($data); $i++) {
			$l = 0;
			foreach ($columns as $col) {
				$spreadsheet->setActiveSheetIndex(0)->setCellValue($this->getChars($l) . ($i + 2), $data[$i][$col]);
				$l++;
			}
		}
		// Set active sheet index to the first sheet, so Excel opens this as the first sheet
		$spreadsheet->setActiveSheetIndex(0);
		$writer = \PhpOffice\PhpSpreadsheet\IOFactory::createWriter($spreadsheet, "Xls");
		$writer->save('upload/excel/' . $sheetname . ".xls");

		return 'upload/excel/' . $sheetname . ".xls";
	}
	public function import($filename = '')
	{
		require 'PhpOffice/vendor/autoload.php';
		$reader = new \PhpOffice\PhpSpreadsheet\Reader\Xls();
		$reader->setLoadSheetsOnly(0);
		$spreadsheet = $reader->load($filename);
		$wsh = $spreadsheet->getActiveSheet();
		$rows = $wsh->toArray();
		$columns = $rows[0];

		$result = [];
		// start from 1 for skiping the columns
		$i = 1;
		for ($i = 1; $i < count($rows); $i++) {
			$c = 0;
			$rwc = [];
			for ($c = 0; $c < count($columns); $c++) {
				$rwc[$columns[$c]] = $rows[$i][$c];
			}
			$result[] = $rwc;
			$rwc = [];
		}
		return $result;
	}
	public function download($files = [])
	{
		$zipname = 'upload/zip_files/backup_' . $this->getDate('Y_m_d__H_t_s') . '.zip';
		$zip = new ZipArchive;
		$zip->open($zipname, ZipArchive::CREATE | ZipArchive::OVERWRITE);
		foreach ($files as $file) {
			if (!is_dir($file)) {
				$zip->addFile($file, str_replace('upload/', '', $file));
			}
		}
		$zip->close();

		//Define header information
		header('Content-Description: File Transfer');
		header('Content-Type: application/octet-stream');
		header("Cache-Control: no-cache, must-revalidate");
		header("Expires: 0");
		header('Content-Disposition: attachment; filename="' . basename($zipname) . '"');
		header('Content-Length: ' . filesize($zipname));
		header('Pragma: public');

		//Clear system output buffer
		flush();

		//Read the size of the file
		// readfile($zipname);
		return 'https://scalpers.site/api_new/test/' . $zipname;
	}
	public function getDate($format = "Y-m-d h:i:s")
	{
		return date($format, strtotime('+1 Hours'));
	}
}



if ($_SERVER['REQUEST_METHOD'] == "POST") {

	$data = file_get_contents('php://input');
	$data = json_decode($data, true);
	require_once "database.php";
	$objData = new db();

	function getCount($tablename, $coon)
	{
		$count = $coon->getData('select count(*) as len from ' . $tablename);
		$count = $count[0]['len'];
		return intval($count);
	}
	function searchStyle($id = 0, $column = "", $value)
	{
		// 1 = equal
		// 2 = start with
		// 3 = contains
		// 4 = end widht

		if ($value === '') return '';

		if ($id === 1) {
			return $column . "='" . $value . "'";
		}
		if ($id === 2) {
			return $column . " LIKE '%" . $value . "'";
		}
		if ($id === 3) {
			return $column . " LIKE '%" . $value . "%'";
		}
		if ($id === 4) {
			return $column . " LIKE '" . $value . "%'";
		}
	}
	if ($data['event_type'] === "SearchInBoots") {

		$result = [];
		$searchStatement = [];

		if ($data['api_id'] != '-1') {
			array_push($searchStatement, "api_id=" . $data['api_id']);
		}

		if ($data['boot_id'] != '') {
			array_push($searchStatement, "bot_id=" . $data['boot_id']);
		}

		if ($data['acc_id'] != '-1') {
			array_push($searchStatement, "account_id=" . $data['acc_id']);
		}

		if ($data['cat_id'] != '-2') {
			array_push($searchStatement, "cat_id=" . $data['cat_id']);
		}

		if ($data['user_id'] != '-1') {
			array_push($searchStatement, "user_id=" . $data['user_id']);
		}
		if ($data['deal_id'] != '') {
			array_push($searchStatement, "deal_id=" . $data['deal_id']);
		}


		if ($data['date_from'] != '') {
			$today_1 = date_format(date_create($data['date_from']), 'Y-m-d');
			$today_2 = date_format(date_create($data['date_to']), 'Y-m-d');
			$today_1 = date('Y-m-d', strtotime($today_1 . '+1 days'));
			$today_2 = date('Y-m-d', strtotime($today_2 . '+1 days'));
			array_push($searchStatement, "closed_at >= CONVERT('" . $today_1 . "', DATE) AND closed_at <= CONVERT('" . $today_2 . "', DATE)");
		}

		if ($data['bot_name'] !== '') {
			array_push($searchStatement, "bot_name LIKE '%" . $data['bot_name'] . "%'");
		}
		if ($data['pair_name'] !== '') {
			array_push($searchStatement, "pair LIKE '%" . $data['pair_name'] . "%'");
		}

		$statmentString = implode(" AND ", $searchStatement);

		if ($statmentString !== '') {
			$result = $objData->getData("SELECT * FROM scalpers_closed_deals  WHERE " . $statmentString);
		}


		echo json_encode(array(
			"message" => "SELECT * FROM	scalpers_closed_deals WHERE " . $statmentString,
			"data" => $result,
			"status" => true
		));
	}

	if ($data['event_type'] === 'getDeals') {
		$deals = [];
		$limit_from = $data['limit_from'];
		$limit_to = $data['limit_to'];
		$len = 0;
		$counts = array(
			"today" => 0,
			"yesterday" => 0,
			"svn_days" => 0,
			"the_days" => 0,
			"last_month" => 0,
			"total" => 0
		);

		$Date = date('Y-m-d');
		$today = date_format(date_create($Date), 'Y-m-d');
		$Yesterday = date('Y-m-d', strtotime($Date . '-1 days'));
		$svn_days = date('Y-m-d', strtotime($Date . '-7 days'));
		$the_days = date('Y-m-d', strtotime($Date . '-30 days'));
		$last_month = date('m', strtotime($Date . '-1 months'));

		$last_month_from = date('Y-' . $last_month . '-01');
		$last_month_to = date('Y-' . $last_month . '-31');

		$bot_is_up24_from_front_end = -1;
		if (isset($data['is_up24'])) {
			$bot_is_up24_from_front_end = intval($data['is_up24']);
		}



		if (intval($data['user_id']) == -1) {
			$deals = $objData->getData('SELECT * FROM `scalpers_closed_deals` where bot_up24=' . $bot_is_up24_from_front_end . ' order by closed_at desc limit ' . $limit_from . ',' . $limit_to);
			$len = $objData->getData('SELECT count(*) as len FROM `scalpers_closed_deals` where bot_up24=' . $bot_is_up24_from_front_end);
			$len = $len[0]['len'];

			$td = $objData->getData('SELECT count(*) as len, user_id, created_at,bot_up24 FROM `scalpers_closed_deals` where bot_up24=' . $bot_is_up24_from_front_end . ' and CONVERT(created_at, DATE) = "' . $today . '"');
			$counts["today"] = $td[0]['len'];

			$yst = $objData->getData('SELECT count(*) as len, user_id, created_at,bot_up24 FROM `scalpers_closed_deals` where bot_up24=' . $bot_is_up24_from_front_end . ' and CONVERT(created_at, DATE) = "' . $Yesterday . '"');
			$counts["yesterday"] = $yst[0]['len'];

			$svn_d = $objData->getData('SELECT count(*) as len, user_id,created_at FROM `scalpers_closed_deals` where bot_up24=' . $bot_is_up24_from_front_end . ' and CONVERT(created_at, DATE) >= "' . $svn_days . '" and CONVERT(created_at, DATE) < "' . $today . '"');
			$counts["svn_days"] = $svn_d[0]['len'];

			$the_d = $objData->getData('SELECT count(*) as len, user_id,created_at FROM `scalpers_closed_deals` where bot_up24=' . $bot_is_up24_from_front_end . ' and CONVERT(created_at, DATE) >= "' . $the_days . '" and CONVERT(created_at, DATE) < "' . $today . '"');
			$counts["the_days"] = $the_d[0]['len'];

			$last_mo = $objData->getData('SELECT count(*) as len, user_id,created_at FROM `scalpers_closed_deals` where bot_up24=' . $bot_is_up24_from_front_end . ' and CONVERT(created_at, DATE) >= "' . $last_month_from . '" and CONVERT(created_at, DATE) <= "' . $last_month_to . '"');
			$counts["last_month"] = $last_mo[0]['len'];

			$deals_total = $objData->getData('SELECT count(*) as len, user_id,created_at FROM `scalpers_closed_deals` where bot_up24=' . $bot_is_up24_from_front_end);
			$counts["total"] = $deals_total[0]['len'];
		} else {
			$deals = $objData->getData('SELECT * FROM `scalpers_closed_deals`  where bot_up24=-1 and user_id=' . intval($data['user_id']) . '  order by closed_at desc limit ' . $limit_from . ',' . $limit_to);
			$len = $objData->getData('SELECT count(*) as len, user_id,created_at  FROM `scalpers_closed_deals` where bot_up24=-1 and user_id=' . intval($data['user_id']));
			$len = $len[0]['len'];

			$td = $objData->getData('SELECT count(*) as len, user_id,created_at  FROM `scalpers_closed_deals` where bot_up24=-1 AND user_id=' . intval($data['user_id']) . ' and bot_up24=-1 and CONVERT(created_at, DATE) = "' . $today . '"');
			$counts["today"] = $td[0]['len'];

			$yst = $objData->getData('SELECT count(*) as len, user_id,created_at  FROM `scalpers_closed_deals` where bot_up24=-1 AND user_id=' . intval($data['user_id']) . ' and bot_up24=-1 and CONVERT(created_at, DATE) = "' . $Yesterday . '"');
			$counts["yesterday"] = $yst[0]['len'];

			$svn_d = $objData->getData('SELECT count(*) as len, user_id,created_at  FROM `scalpers_closed_deals` where bot_up24=-1 AND user_id=' . intval($data['user_id']) . ' and bot_up24=-1 and CONVERT(created_at, DATE) >= "' . $svn_days . '" and CONVERT(created_at, DATE) < "' . $today . '"');
			$counts["svn_days"] = $svn_d[0]['len'];

			$the_d = $objData->getData('SELECT count(*) as len, user_id,created_at  FROM `scalpers_closed_deals` where bot_up24=-1 AND user_id=' . intval($data['user_id']) . ' and bot_up24=-1 and CONVERT(created_at, DATE) >= "' . $the_days . '" and CONVERT(created_at, DATE) < "' . $today . '"');
			$counts["the_days"] = $the_d[0]['len'];

			$last_mo = $objData->getData('SELECT count(*) as len, user_id,created_at  FROM `scalpers_closed_deals` where bot_up24=-1 AND user_id=' . intval($data['user_id']) . ' and bot_up24=-1 and CONVERT(created_at, DATE) >= "' . $last_month_from . '" and CONVERT(created_at, DATE) <= "' . $last_month_to . '"');
			$counts["last_month"] = $last_mo[0]['len'];

			$deals_total = $objData->getData('SELECT count(*) as len, user_id,created_at  FROM `scalpers_closed_deals` where bot_up24=-1 and user_id=' . intval($data['user_id']));
			$counts["total"] = $deals_total[0]['len'];
		}

		echo json_encode(array(
			"message" => "",
			"data" => array(
				"deals" => $deals,
				"len" => $len,
				"counts" => $counts
			),
			"status" => true
		));
	}
	if ($data['event_type'] === 'getDealsScore') {
		$deals = [];
		$limit_from = $data['limit_from'];
		$limit_to = $data['limit_to'];
		$len = 0;

		if (intval($data['user_id']) == 1) {
			$deals = $objData->getData('SELECT * FROM `scalpers_closed_deals` where bot_up24 =1 limit ' . $limit_from . ',' . $limit_to);
			$len = $objData->getData('SELECT count(*) as len FROM `scalpers_closed_deals`  where bot_up24 =1');
			$len = $len[0]['len'];
		} else {
			$deals = $objData->getData('SELECT * FROM `scalpers_closed_deals`  where bot_up24 =1 and user_id=' . intval($data['user_id']) . ' limit ' . $limit_from . ',' . $limit_to);
			$len = $objData->getData('SELECT * FROM `scalpers_closed_deals`  where bot_up24 =1 and user_id=' . intval($data['user_id']));
			$len = $len[0]['len'];
		}

		echo json_encode(array(
			"message" => "",
			"data" => array(
				"deals" => $deals,
				"len" => $len
			),
			"status" => true
		));
	}
	if ($data['event_type'] === 'export') {
		$result = [];
		$searchStatement = [];
		if (intval($data['filter']) === 0) {
			$result = $objData->getData("SELECT * FROM scalpers_closed_deals");
		} else {
			// bot name
			$bot_name = searchStyle(intval($data['bot_id']), 'bot_name', $data['bot_name']);

			// pair name
			$pair_name = searchStyle(intval($data['pair_id']), 'pair', $data['pair_name']);



			if ($data['api_id'] != '-1') {
				array_push($searchStatement, "api_id=" . $data['api_id']);
			}

			if ($data['boot_id'] != '') {
				array_push($searchStatement, "bot_id=" . $data['boot_id']);
			}

			if ($data['acc_id'] != '-1') {
				array_push($searchStatement, "account_id=" . $data['acc_id']);
			}

			if ($data['cat_id'] != '-2') {
				array_push($searchStatement, "cat_id=" . $data['cat_id']);
			}

			if ($data['user_id'] != '-1') {
				array_push($searchStatement, "user_id=" . $data['user_id']);
			}
			if ($data['deal_id'] != '') {
				array_push($searchStatement, "deal_id=" . $data['deal_id']);
			}


			if ($data['date_from'] != '') {
				$today_1 = date_format(date_create($data['date_from']), 'Y-m-d');
				$today_2 = date_format(date_create($data['date_to']), 'Y-m-d');
				$today_1 = date('Y-m-d', strtotime($today_1 . '+1 days'));
				$today_2 = date('Y-m-d', strtotime($today_2 . '+1 days'));
				array_push($searchStatement, "closed_at >= CONVERT('" . $today_1 . "', DATE) AND closed_at <= CONVERT('" . $today_2 . "', DATE)");
			}

			if ($bot_name !== '') {
				array_push($searchStatement, $bot_name);
			}
			if ($pair_name !== '') {
				array_push($searchStatement, $pair_name);
			}

			$statmentString = implode(" AND ", $searchStatement);

			if ($statmentString !== '') {
				$result = $objData->getData("SELECT * FROM scalpers_closed_deals  WHERE " . $statmentString);
			}
		}
		$excl = new export_excel($result);
		
	}
	
	if($data['event_type'] === 'getTableTemplate')
	{
	    $tableTemplate = $objData->getData("SELECT * FROM table_column_template WHERE col_type='report'");
	    	echo json_encode(array(
			"message" => "",
			"data" => $tableTemplate,
			"status" => true
		));
	}
	
}
