<?php

// Allow PHP API.
header('Access-Control-Allow-Origin: *');
header('Content-Type: application/json');
header("Access-Control-Allow-Methods: GET, POST, OPTIONS, PUT, DELETE");
header("Allow: GET, POST, OPTIONS, PUT, DELETE");
header("Access-Control-Allow-Headers: X-API-KEY, Origin, X-Requested-With, Content-Type, Accept, Access-Control-Request-Method, Access-Control-Allow-Origin");


require_once('mail/SMTP.php');
require_once('mail/PHPMailer.php');
require_once('mail/Exception.php');

use \PHPMailer\PHPMailer\PHPMailer;
use \PHPMailer\PHPMailer\Exception;


if ($_SERVER['REQUEST_METHOD'] == "POST") {

    $data = file_get_contents('php://input');
    $data = json_decode($data, true);
    require_once "database.php";
    $objData = new db();

    function getCount($tablename, $coon)
    {
        $count = $coon->getData('select count(*) as len from ' . $tablename);
        $count = $count[0]['len'];
        return intval($count);
    }

    if ($data['event_type'] == "getUsers") {
        $limit_from = intval($data['limit_from']);
        $limit_to = intval($data['limit_to']);
        $users = $objData->getData('select * from scalpers_users limit ' . $limit_from . ',' . $limit_to);

        $i = 0;
        for ($i = 0; $i < count($users); $i++) {
            $users[$i]['user_bots'] = $objData->getData("SELECT * FROM scalpers_bots WHERE user_id=" . $users[$i]['user_id']);
        }
        echo json_encode(array(
            "message" => "",
            "data" => array(
                "users" => $users,
                "len" => getCount('scalpers_users', $objData)
            ),
            "status" => true
        ));
    }

    if ($data['event_type'] === 'getUserDeals') {
        $deals = [];
        $len = 0;
        $limit_from = $data['limit_from'];
        $limit_to = $data['limit_to'];
        
        $default1 = $objData->getData("SELECT * FROM defalut_settings WHERE def_name='timeout_hour'");
        $default2 = $objData->getData("SELECT * FROM defalut_settings WHERE def_name='deal_close_cond'");
        $default3 = $objData->getData("SELECT * FROM defalut_settings WHERE def_name='deal_close_cond_ml'");
        
        $hours_default = floatval($default1[0]['def_value']);
        $close_deal_per_default = floatval($default2[0]['def_value']);
        $close_deal_per_default_ml = intval($default3[0]['def_value']);

        
        if (intval($data['user_id']) === 1) {
            $deals = $objData->getData('select * from scalpers_temp_deals,scalpers_users where scalpers_temp_deals.user_id = scalpers_users.user_id ORDER BY scalpers_temp_deals.deal_id DESC limit ' . $limit_from . ',' . $limit_to);
            $len = $objData->getData('select count(*) as len from scalpers_temp_deals,scalpers_users where scalpers_temp_deals.user_id = scalpers_users.user_id ORDER BY scalpers_temp_deals.deal_id');
            $len = $len[0]['len'];
        } else {
            $deals = $objData->getData('select * from scalpers_temp_deals,scalpers_users where scalpers_temp_deals.user_id=' . $data['user_id'] . ' and scalpers_users.user_id=' . $data['user_id'] . ' ORDER BY scalpers_temp_deals.deal_id DESC limit ' . $limit_from . ',' . $limit_to);
            $len = $objData->getData('select count(*) as len from scalpers_temp_deals,scalpers_users where scalpers_temp_deals.user_id=' . $data['user_id'] . ' and scalpers_users.user_id=' . $data['user_id'] . ' ORDER BY scalpers_temp_deals.deal_id');
            $len = $len[0]['len'];
        }
        echo json_encode(array(
            "message" => "",
            "data" => array(
                "deals" => $deals,
                "len" => $len,
                "time_out" => $hours_default,
                "close_deal_cond" => $close_deal_per_default,
                "close_deal_cond_ml" => $close_deal_per_default_ml
            ),
            "status" => true
        ));
    }
    
    if ($data['event_type'] === 'getUserDealsGroups') {
        $deals = [];
        $len = 0;
        $limit_from = $data['limit_from'];
        $limit_to = $data['limit_to'];
        if (intval($data['user_id']) === 1) {
            $deals = $objData->getData('select * from scalpers_temp_deals,scalpers_users where scalpers_temp_deals.user_id = scalpers_users.user_id AND scalpers_temp_deals.deal_is_group=2 ORDER BY scalpers_temp_deals.deal_id DESC limit ' . $limit_from . ',' . $limit_to);
            $len = $objData->getData('select count(*) as len from scalpers_temp_deals,scalpers_users where scalpers_temp_deals.user_id = scalpers_users.user_id AND  AND scalpers_temp_deals.deal_is_group=2 ORDER BY scalpers_temp_deals.deal_id');
            $len = $len[0]['len'];
        } else {
            $deals = $objData->getData('select * from scalpers_temp_deals,scalpers_users where scalpers_temp_deals.user_id=' . $data['user_id'] . ' and scalpers_users.user_id=' . $data['user_id'] . '  AND scalpers_temp_deals.deal_is_group=2 ORDER BY scalpers_temp_deals.deal_id DESC limit ' . $limit_from . ',' . $limit_to);
            $len = $objData->getData('select count(*) as len from scalpers_temp_deals,scalpers_users where scalpers_temp_deals.user_id=' . $data['user_id'] . ' and scalpers_users.user_id=' . $data['user_id'] . '  AND scalpers_temp_deals.deal_is_group=2 ORDER BY scalpers_temp_deals.deal_id');
            $len = $len[0]['len'];
        }
        echo json_encode(array(
            "message" => "",
            "data" => array(
                "deals" => $deals,
                "len" => $len
            ),
            "status" => true
        ));
    }

    if ($data['event_type'] == "getUserBoots") {
        $limit_from = $data['limit_from'];
        $limit_to = $data['limit_to'];
        $boots = $objData->getData('select bot_id,user_id from scalpers_bots where user_id=' . $data['user_id'] . ' limit ' . $limit_from . ',' . $limit_to);
        $i = 0;
        $new_bootsOf_array = [];
        $new_bootsOfTemp_array = [];
        $tub = $objData->getData('select user_id,bot_id from scalpers_temp_deals where user_id=' . $data['user_id']);
        foreach ($tub as $item) {
            array_push(
                $new_bootsOfTemp_array,
                $item['bot_id']
            );
        }
        foreach ($boots as $item) {
            array_push(
                $new_bootsOf_array,
                $item['bot_id']
            );
        }
        if (isset($data['eType'])) {
            echo json_encode(array(
                "message" => "",
                "data" => array(
                    "private" => $new_bootsOf_array,
                    "home" => $new_bootsOfTemp_array,
                    "len" => $objData->getData('select count(*) as len from scalpers_bots where user_id=' . $data['user_id'])[0]['len']
                ),
                "status" => true
            ));
        } else {
            echo json_encode(array(
                "message" => "",
                "data" => $new_bootsOf_array,
                "status" => true
            ));
        }
    }

    if ($data['event_type'] == "getUsersBoots") {
        $boots = $objData->getData('select bot_id from scalpers_bots');
        $i = 0;
        $new_bootsOf_array = [];
        for ($i = 0; $i < count($boots); $i++) {
            array_push($new_bootsOf_array,  $boots[$i]['bot_id']);
        }
        echo json_encode(array(
            "message" => "",
            "data" => $new_bootsOf_array,
            "status" => true
        ));
    }

    if ($data['event_type'] == "getUser") {
        $users = $objData->getData('select * from scalpers_users where user_id=' . $data['user_id']);
        if ($users) {
            echo json_encode(array(
                "message" => "",
                "data" => $users[0],
                "status" => true
            ));
        } else {
            echo json_encode(array(
                "message" => "",
                "data" => [],
                "status" => true
            ));
        }
    }

    if ($data['event_type'] == 'getUserScore') {
        $ar = array(
            "score_m" => 0,
            "score_p" => 0,
            "score_m_paper" => 0,
            "score_p_papre" => 0,
        );
        if ($data['user_id'] == 'admin') {
            $from = $data['from'];
            $to = $data['to'];
            $users = $objData->getData('select * from scalpers_up24');
            $i = 0;
            for ($i = 0; $i < count($users); $i++) {
                $usr = $objData->getData("SELECT * FROM scalpers_users WHERE user_id=" . $users[$i]['user_id']);
                $users[$i]['user_name'] = $usr[0]['user_name'];
            }
            $nUsers = $objData->getData('select * from scalpers_users limit ' . $from . ',' . $to);
            $users_len = $objData->getData('select count(*) as len from scalpers_users');
            $users_len = $users_len[0]['len'];
            echo json_encode(array(
                "message" => "",
                "data" => array(
                    "users" => $users,
                    "normal_users" => $nUsers,
                    "len" => $users_len
                ),
                "status" => true
            ));
        } else {
            $users = $objData->getData('select * from scalpers_up24 where user_id=' . $data['user_id']);
            echo json_encode(array(
                "message" => "",
                "data" => $users,
                "status" => true
            ));
        }
    }


    if ($data['event_type'] == "LoginUser") {
        $users = $objData->getData("SELECT * FROM scalpers_users WHERE user_link_name='" . str_replace(' ', '_', $data['user_email']) . "' AND user_password='" . md5($data['user_password']) . "'");
        if ($users) {
            echo json_encode(array(
                "message" => "",
                "data" => $users[0],
                "status" => true
            ));
        } else {
            echo json_encode(array(
                "message" => "Can't Login.!",
                "data" => [],
                "status" => false
            ));
        }
    }

    if ($data['event_type'] === 'createUser') {
        $email = $objData->getData("SELECT * FROM scalpers_users WHERE user_email='" . $data['user_email'] . "'");
        $name = $objData->getData("SELECT * FROM scalpers_users WHERE user_link_name='" . str_replace(' ', '_', $data['user_link_name']) . "'");
        if ($name) {
            echo json_encode(array(
                "message" => "Username is registred.!",
                "data" => "",
                "status" => false
            ));
        } else if ($email) {
            echo json_encode(array(
                "message" => "Email is registred.!",
                "data" => "",
                "status" => false
            ));
        } else {
            $save_user = $objData->execData(
                "insert into scalpers_users (user_link_name,user_name,user_email,user_password) values(?,?,?,?)",
                [
                    str_replace(' ', '_', $data['user_link_name']),
                    str_replace(' ', '_', $data['user_link_name']),
                    $data['user_email'],
                    md5($data['user_password'])
                ]
            );
            if ($save_user) {
                echo json_encode(array(
                    "message" => "",
                    "data" => [],
                    "status" => true
                ));
            } else {
                echo json_encode(array(
                    "message" => "",
                    "data" => [],
                    "status" => false
                ));
            }
        }
    }

    if ($data['event_type'] == "updateUser") {
        $userByEmail = $objData->getData("select user_id,user_email from scalpers_users where user_email='" . $data['user_email'] . "' and user_id!=" . $data['user_id']);
        $userByUsername = $objData->getData("select user_id,user_link_name from scalpers_users where user_link_name='" .  str_replace(' ', '_', $data['user_link_name']) . "' and user_id!=" . $data['user_id']);
        $userByTelegramID = $objData->getData("select user_id,user_email from scalpers_users where user_telegram_id='" . $data['user_telegram_id'] . "' and user_id!=" . $data['user_id']);
        if ($userByEmail) {
            echo json_encode(array(
                "message" => "Email not allowed.!",
                "data" => [],
                "status" => false
            ));
        } else if ($userByTelegramID) {
            echo json_encode(array(
                "message" => "Telegram ID not allowed.!",
                "data" => [],
                "status" => false
            ));
        } else if ($userByUsername) {
            echo json_encode(array(
                "message" => "Username not allowed.!",
                "data" => [],
                "status" => false
            ));
        } else {
            $update_user = $objData->execData(
                "update scalpers_users set user_name=?,user_email=?,user_telegram_id=?,user_type=?,user_score=? where user_id=?",
                [
                    $data["user_name"],
                    $data['user_email'],
                    $data['user_telegram_id'],
                    intval($data["user_type"]),
                    intval($data["user_score"]),
                    intval($data['user_id'])
                ]
            );
            if ($update_user) {
                echo json_encode(array(
                    "message" => "Updated successfuly.!",
                    "data" => [],
                    "status" => true
                ));
            } else {
                echo json_encode(array(
                    "message" => "Can't updated data.!",
                    "data" => [],
                    "status" => false
                ));
            }
        }
    }

    if ($data['event_type'] == "updateUserByUser") {
        $userByEmail = $objData->getData("select user_id,user_email from scalpers_users where user_email='" . $data['user_email'] . "' and user_id!=" . $data['user_id']);
        $userByUsername = $objData->getData("select user_id,user_link_name from scalpers_users where user_link_name='" .  str_replace(' ', '_', $data['user_link_name']) . "' and user_id!=" . $data['user_id']);
        $userByTelegramID = $objData->getData("select user_id,user_email from scalpers_users where user_telegram_id='" . $data['user_telegram_id'] . "' and user_id!=" . $data['user_id']);
        if ($userByEmail) {
            echo json_encode(array(
                "message" => "Email not allowed.!",
                "data" => [],
                "status" => false
            ));
        } else if ($userByTelegramID) {
            echo json_encode(array(
                "message" => "Telegram ID not allowed.!",
                "data" => [],
                "status" => false
            ));
        } else if ($userByUsername) {
            echo json_encode(array(
                "message" => "Username not allowed.!",
                "data" => [],
                "status" => false
            ));
        } else {
            $update_user = $objData->execData(
                "update scalpers_users set user_name=?,user_link_name=?,user_email=?,user_telegram_id=? where user_id=?",
                [
                    $data["user_name"],
                    str_replace(' ', '_', $data['user_link_name']),
                    $data['user_email'],
                    $data['user_telegram_id'],
                    intval($data['user_id'])
                ]
            );
            if ($update_user) {
                echo json_encode(array(
                    "message" => "Updated successfuly.!",
                    "data" => [],
                    "status" => true
                ));
            } else {
                echo json_encode(array(
                    "message" => "Can't updated data.!",
                    "data" => [],
                    "status" => false
                ));
            }
        }
    }

    if ($data['event_type'] == "updatePassword") {
        $update_user = $objData->execData(
            "update scalpers_users set user_password=? where user_email='" . $data['user_email'] . "'",
            [
                md5($data["user_password"])
            ]
        );
        if ($update_user) {
            echo json_encode(array(
                "message" => "Updated successfuly.!",
                "data" => [],
                "status" => true
            ));
        } else {
            echo json_encode(array(
                "message" => "Can't updated data.!",
                "data" => [],
                "status" => false
            ));
        }
    }

    if ($data['event_type'] === 'updateUserBoots') {
        $bot = $objData->execData("UPDATE scalpers_bots SET user_id=?,tmp_user_id=?,cat_id=? WHERE bot_id=?", [
            $data['user_id'],
            $data['tmp_user_id'],
            $data['cat_id'],
            $data['boot_id']
        ]);
        if ($bot) {
            echo json_encode(array(
                "message" => "Updated successfuly.!",
                "data" => [],
                "status" => true
            ));
        } else {
            echo json_encode(array(
                "message" => "Can't updated data.!",
                "data" => [],
                "status" => false
            ));
        }
    }

    if ($data['event_type'] === 'updateUserBootsTMP') {
        $bot = $objData->execData("UPDATE scalpers_bots SET tmp_user_id=? WHERE bot_id=?", [
            $data['tmp_user_id'],
            $data['boot_id']
        ]);
        if ($bot) {
            echo json_encode(array(
                "message" => "Updated successfuly.!",
                "data" => [],
                "status" => true
            ));
        } else {
            echo json_encode(array(
                "message" => "Can't updated data.!",
                "data" => [],
                "status" => false
            ));
        }
    }

    if ($data['event_type'] == "addNewUser") {
        $userByEmail = $objData->getData("select user_id,user_email from scalpers_users where user_email='" . $data['user_email'] . "'");
        $userByTelegramID = $objData->getData("select user_id,user_email from scalpers_users where user_telegram_id='" . $data['user_telegram_id'] . "'");
        if ($userByEmail) {
            echo json_encode(array(
                "message" => "Email not allowed.!",
                "data" => [],
                "status" => false
            ));
        } else if ($userByTelegramID) {
            echo json_encode(array(
                "message" => "Telegram ID not allowed.!",
                "data" => [],
                "status" => false
            ));
        } else {
            $save_user = $objData->execData(
                "insert into scalpers_users (user_link_name,user_name,user_email,user_telegram_id,user_type) values(?,?,?,?,?)",
                [
                    str_replace(' ', '_', $data["user_name"]),
                    $data["user_name"],
                    $data['user_email'],
                    $data['user_telegram_id'],
                    intval($data["user_type"])
                ]
            );
            if ($save_user) {
                echo json_encode(array(
                    "message" => "User added successfuly.!",
                    "data" => [],
                    "status" => true
                ));
            } else {
                echo json_encode(array(
                    "message" => "Can't add User.!",
                    "data" => [],
                    "status" => false
                ));
            }
        }
    }

    if ($data['event_type'] == "deleteUser") {
        $delete_user = $objData->execData(
            "delete from scalpers_users where user_id=?",
            [
                $data["user_id"]
            ]
        );
        if ($delete_user) {
            echo json_encode(array(
                "message" => "Deleted user successfuly.!",
                "data" => [],
                "status" => true
            ));
        } else {
            echo json_encode(array(
                "message" => "Can't delete User.!",
                "data" => [],
                "status" => false
            ));
        }
    }

    if ($data['event_type'] === "sendRestore_code") {
        $userByEmail = $objData->getData("select user_email,user_link_name,user_password from scalpers_users where user_email='" . $data['user_email'] . "'");
        if ($userByEmail) {
            $settings = $objData->getData('select * from scalpers_settings');
            $email = $data['user_email'];


            $mail = new PHPMailer(true); // Passing `true` enables exceptions

            try {
                //settings
                $mail->SMTPDebug = 0; // Enable verbose debug output
                $mail->isSMTP(); // Set mailer to use SMTP
                $mail->Host = 'scalpers.site';
                $mail->SMTPAuth = true; // Enable SMTP authentication
                $mail->Username = 'noreply@scalpers.site'; // SMTP username
                $mail->Password = 'Pass*2023'; // SMTP password
                $mail->SMTPSecure = 'ssl';
                $mail->Port = 465;

                $mail->setFrom('noreply@scalpers.site', $settings[0]['app_name'] . ' - Restore Account');

                //recipient
                $mail->addAddress($email, 'Hi,' . $userByEmail[0]['user_link_name']);     // Add a recipient

                $c = substr(rand(), 4, 10);
                //content
                $mail->isHTML(true); // Set email format to HTML
                $mail->Subject = 'Hi,' . $userByEmail[0]['user_link_name'];
                $inp_style = "padding:5px 10px;border:none;borde-radius: 0px;text-align:center;font-size:1rem;";
                $mail->Body = '<h3>Welcome ' . $userByEmail[0]['user_link_name'] . '</h3>Restore Code : <b style="' . $inp_style . '">' . $c . '</b>';
                $mail->AltBody = '';

                $mail->send();

                echo json_encode(array(
                    "message" => "Restore mail sent successfuly.!",
                    "data" => array(
                        "code" => $c,
                        "user" => $userByEmail[0]['user_email']
                    ),
                    "status" => true
                ));
            } catch (Exception $e) {
                echo json_encode(array(
                    "message" => "Can't send mail.!",
                    "data" => [],
                    "status" => false
                ));
            }
        } else {
            echo json_encode(array(
                "message" => "Can't find User.!",
                "data" => [],
                "status" => false
            ));
        }
    }

    if ($data['event_type'] === 'addNewTempDeal') {
        $IsHave = $objData->getData("select * from scalpers_temp_deals where bot_id=" . $data['bot_id'] . " AND deal_id=" . $data['deal_id']);
        if ($IsHave) {
            echo json_encode(array(
                "message" => "Error",
                "data" => [],
                "status" => false
            ));
        } else {
            $tmpUserID = $objData->getData("SELECT * FROM scalpers_bots WHERE bot_id=" . intval($data['bot_id']));
            
            $objData->execData("UPDATE scalpers_bots SET user_id=?,tmp_user_id=? WHERE bot_id=?", [
            $data["user_id"],
            $tmpUserID[0]['user_id'],
            $data['bot_id']
            ]);
            $save_deal = $objData->execData(
                "insert into scalpers_temp_deals (user_id, bot_id, deal_id,api_id) values(?,?,?,?)",
                [
                    $data["user_id"],
                    $data['bot_id'],
                    $data['deal_id'],
                    $data['api_id']
                ]
            );
            if ($save_deal) {
                echo json_encode(array(
                    "message" => "Successfuly.!",
                    "data" => [],
                    "status" => true
                ));
            } else {
                echo json_encode(array(
                    "message" => "Error",
                    "data" => [],
                    "status" => false
                ));
            }
        }
    }

    if ($data['event_type'] === 'addNewDealToArchive') {
        $save_deal = $objData->execData(
            "insert into scalpers_closed_deals (
                account_id,
                account_name,
                bot_id,
                bot_name,
                closed_at,
                created_at,
                sold_average_price,
                base_order_average_price,
                final_profit,
                final_profit_percentage,
                finished,
                deal_id,
                pair,
                updated_at,
                strategy,
                user_id
            ) values(
                ?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?
            )",
            [
                $data['account_id'],
                $data['account_name'],
                $data['bot_id'],
                $data['bot_name'],
                $data['closed_at'],
                $data['created_at'],
                $data['sold_average_price'],
                $data['base_order_average_price'],
                $data['final_profit'],
                $data['final_profit_percentage'],
                $data['finished'],
                $data['deal_id'],
                $data['pair'],
                $data['updated_at'],
                $data['strategy'],
                $data['user_id']
            ]
        );

        // make boot is general or opened
        $objData->execData("UPDATE scalpers_bots SET deal_id=?,active_deals_count=? WHERE bot_id=?", [
            0,
            0,
            intval($data['bot_id'])
        ]);

        // $objData->execData(
        //     "DELETE FROM scalpers_temp_deals WHERE user_id=? AND bot_id=?",
        //     [
        //         $data['user_id'],
        //         $data['bot_id']
        //     ]
        // );

        if ($save_deal) {
            echo json_encode(array(
                "message" => "Successfuly.!",
                "data" => [],
                "status" => true
            ));
        } else {
            echo json_encode(array(
                "message" => "Error",
                "data" => [],
                "status" => false
            ));
        }
    }

    if ($data['event_type'] === 'addHOMENewDealToArchive') {
        $account = $objData->getData("SELECT * FROM scalpers_accounts WHERE acc_id=" . $data['account_id']);
        if (count($account)) {
            $account = $account[0]['acc_name'];
        } else {
            $account = 'No name';
        }
        $format = "Y-m-d h:i:s"; //or something else that date() accepts as a format
        $from = date_format(date_create($data['created_at']), $format);
        $to = date($format);

        //Calculate the date difference based on timestamp values
        $difference = strtotime($from) - strtotime($to);

        //Calculate difference in days
        $days = abs($difference / (60 * 60) / 24);
        $us = $objData->getData("SELECT * FROM scalpers_users WHERE user_id=" . $data['user_id']);
        $us = $us[0];

        $in_up24 = $objData->getData("SELECT * FROM scalpers_up24 WHERE user_id=" . $data['user_id'] . ' AND bot_id=' . $data['bot_id'] . ' AND deal_id=' . $data['deal_id']);
        if (count($in_up24) === 0) {
            if (intval($data['up24']) == -1) {
                if (strpos(strtolower($data['account_name']), 'paper') > -1) {
                    $objData->execData("insert into scalpers_up24(bot_id, user_id, deal_id, is_paper,is_timeout) values(?,?,?,?,?)", [
                        $data['bot_id'],
                        $data['user_id'],
                        $data['deal_id'],
                        1,
                        2
                    ]);
                } else {
                    $objData->execData("insert into scalpers_up24(bot_id, user_id, deal_id, is_paper,is_timeout) values(?,?,?,?,?)", [
                        $data['bot_id'],
                        $data['user_id'],
                        $data['deal_id'],
                        2,
                        2
                    ]);
                }
            } else {
                if (strpos(strtolower($data['account_name']), 'paper') > -1) {
                    $objData->execData("insert into scalpers_up24(bot_id, user_id, deal_id, is_paper,is_timeout) values(?,?,?,?,?)", [
                        $data['bot_id'],
                        $data['user_id'],
                        $data['deal_id'],
                        1,
                        1
                    ]);
                } else {
                    $objData->execData("insert into scalpers_up24(bot_id, user_id, deal_id, is_paper,is_timeout) values(?,?,?,?,?)", [
                        $data['bot_id'],
                        $data['user_id'],
                        $data['deal_id'],
                        2,
                        1
                    ]);
                }
            }
        }

        if (intval($data['up24']) == -1) {
            $tmpUserID = $objData->getData("SELECT * FROM scalpers_bots WHERE bot_id=" . intval($data['bot_id']));
            $tmpUserID_iD = $tmpUserID[0]['tmp_user_id'];
            $tmpUserID_cat = $tmpUserID[0]['cat_id'];
            // make boot is general or opened
            $objData->execData("UPDATE scalpers_bots SET deal_id=?,active_deals_count=?,user_id=?,tmp_user_id=? WHERE bot_id=?", [
                0,
                0,
                //  لم يتم تحديد مستخدم موقت
                // -1 = show
                // -2 = hidden
                // category -1 is general
                $tmpUserID_iD == '' ? $tmpUserID[0]['user_id'] : intval($tmpUserID_iD), // Status/User
                '',
                intval($data['bot_id'])
            ]);
            $objData->execData(
                "DELETE FROM scalpers_temp_deals WHERE user_id=? AND bot_id=?",
                [
                    $data['user_id'],
                    $data['bot_id']
                ]
            );
        }


        // get deal from report
        $bb = $objData->getData("SELECT * FROM scalpers_closed_deals WHERE bot_id=" . $data['bot_id'] . " AND deal_id=" . $data['deal_id']);

        $save_deal = true;

        if (count($bb) === 0) {
            $save_deal = $objData->execData(
                "insert into scalpers_closed_deals (
                account_id,
                account_name,
                bot_id,
                bot_name,
                closed_at,
                created_at,
                sold_average_price,
                base_order_average_price,
                final_profit,
                final_profit_percentage,
                finished,
                deal_id,
                pair,
                updated_at,
                strategy,
                user_id,
                user_name,
                bot_up24,
                type_is_up24
            ) values(
                ?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?
            )",
                [
                    $data['account_id'],
                    $account,
                    $data['bot_id'],
                    $data['bot_name'],
                    date_format(date_create($data['closed_at']), $format),
                    $from,
                    $data['sold_average_price'],
                    $data['base_order_average_price'],
                    $data['final_profit'],
                    $data['final_profit_percentage'],
                    $data['finished'],
                    $data['deal_id'],
                    $data['pair'],
                    $data['updated_at'],
                    $data['strategy'],
                    $data['user_id'],
                    $data['user_name'],
                    $data['up24'],
                    $data['up24'] == 1 ? 1 : -1
                ]
            );
        }

        if ($save_deal) {
            echo json_encode(array(
                "message" => "Successfuly.!",
                "data" => [],
                "status" => true
            ));
        } else {
            echo json_encode(array(
                "message" => "Error",
                "data" =>  [],
                "status" => false
            ));
        }
    }

    if ($data['event_type'] == "cancelDeal") {
        $cancel_deal = $objData->execData(
            "delete from scalpers_temp_deals where deal_id=?",
            [
                $data["deal_id"]
            ]
        );
        if ($cancel_deal) {
            echo json_encode(array(
                "message" => "Successfuly.!",
                "data" => [],
                "status" => true
            ));
        } else {
            echo json_encode(array(
                "message" => "Error",
                "data" => [],
                "status" => false
            ));
        }
    }

    if ($data['event_type'] == "getDeals") {
        $temp_deals = $objData->getData('select * from scalpers_temp_deals where user_id=' . $data['user_id']);
        echo json_encode(array(
            "message" => "",
            "data" => $temp_deals,
            "status" => true
        ));
    }

    if ($data['event_type'] == 'MakeBootIsGeneral') {
        $bot = $objData->execData("UPDATE scalpers_bots SET user_id=?,cat_id=? WHERE bot_id=?", [
            $data['status'],
            $data['cat_id'],
            $data['bot_id']
        ]);
        echo json_encode(array(
            "message" => "Updated successfuly.!",
            "data" => [],
            "status" => true
        ));
    }
    if ($data['event_type'] === 'addFavPair') {
        $objData->execData("DELETE FROM scalpers_favs WHERE user_id=?", [intval($data['user_id'])]);
        $pairs = $data['pairs'];
        foreach ($pairs as $pair) {
            $objData->execData(
                'INSERT INTO scalpers_favs (user_id,pair) VALUES(?,?)',
                [
                    intval($data['user_id']),
                    $pair
                ]
            );
        }
        echo json_encode(array(
            "status" => true,
            "data" => [],
            "message" => ""
        ));
    }

    if ($data['event_type'] === 'getUserFav') {
        $pairs = $objData->getData('SELECT * FROM scalpers_favs WHERE user_id=' . intval($data['user_id']));
        echo json_encode(array(
            "status" => true,
            "data" => $pairs,
            "message" => ""
        ));
    }
    if ($data['event_type'] === 'UpdateUserSorted') {
        $upstor = $objData->execData('UPDATE scalpers_users SET user_strategy_sorted=?,user_pair_stored=? WHERE user_id=?', [
            $data['sort_strategy'],
            $data['sort_az'],
            $data['user_id']
        ]);
        echo json_encode(array(
            "status" => true,
            "data" => [],
            "message" => ""
        ));
    }
    if ($data['event_type'] === 'getBotsByCatID') {
        $from = $data['limit_from'];
        $to = $data['limit_to'];
        $nl = $objData->getData('SELECT * FROM scalpers_bots as b,scalpers_accounts as a WHERE a.acc_id = b.account_id and a.acc_status=1 AND b.user_id = -1 AND b.cat_id=' . intval($data['cat_id']) . ' limit ' . $from . ',' . $to);
        $len = $objData->getData('SELECT count(*) as len FROM scalpers_bots as b,scalpers_accounts as a WHERE a.acc_id = b.account_id AND a.acc_status=1 AND b.cat_id=' . $data['cat_id']);
        $len = $len[0]['len'];
        echo json_encode(array(
            "status" => true,
            "data" => array(
                "bots" => $nl,
                "len" => $len
            ),
            "message" => ""
        ));
    }
    
    if ($data['event_type'] == 'getUserCountDeals') {
        $dealsC = $objData->getData("SELECT count(*) as len FROM scalpers_temp_deals WHERE user_id=" . intval($data['user_id']));
        $fromRep = $objData->getData("SELECT count(*) as len FROM scalpers_closed_deals WHERE user_id=" . intval($data['user_id']));
        $len = 0;
        
        $dealsC = intval($dealsC[0]['len']);
        $fromRep = intval($fromRep[0]['len']);
        
        // if($dealsC > $fromRep)
        // {
        //     $len = $dealsC - $fromRep;
        // }
        // else
        // {
        //     $len = $fromRep - $dealsC;
        // }
        
        echo json_encode(array(
            "status" => true,
            "data" => $dealsC,
            "message" => ""
        ));
    }
    if ($data['event_type'] == 'getUserCountDealsUp24') {
        $dealsC = $objData->getData("SELECT count(*) as len FROM scalpers_temp_deals WHERE user_id=" . intval($data['user_id']) . " AND deal_is_group=2");
        $fromRep = $objData->getData("SELECT count(*) as len FROM scalpers_closed_deals WHERE user_id=" . intval($data['user_id']));
        $len = 0;
        
        $dealsC = intval($dealsC[0]['len']);
        $fromRep = intval($fromRep[0]['len']);
        
        // if($dealsC > $fromRep)
        // {
        //     $len = $dealsC - $fromRep;
        // }
        // else
        // {
        //     $len = $fromRep - $dealsC;
        // }
        
        echo json_encode(array(
            "status" => true,
            "data" => $dealsC,
            "message" => ""
        ));
    }
    if ($data['event_type'] == 'updateUserCat') {
        $dealsC = $objData->execData("UPDATE scalpers_users SET cat_selected=? WHERE user_id=?", [$data['cat_name'], intval($data['user_id'])]);
        echo json_encode(array(
            "status" => true,
            "data" => [],
            "message" => ""
        ));
    }

    if ($data['event_type'] == 'user_history') {
        $format = "Y-m-d h:i:s";
        $date = date($format);
        $deal_by_status = $objData->getData("SELECT * FROM user_history WHERE deal_status='" . $data['deal_status'] . "' AND deal_id=" . intval($data['deal_id']));
        if (count($deal_by_status) === 0) {
            $objData->execData(
                'INSERT INTO user_history (action_name,action_date,deal_id,bot_id,user_id,deal_status,deal_started_at,deal_close_at) VALUES(?,?,?,?,?,?,?,?)',
                [
                    $data['action_name'],
                    $date,
                    intval($data['deal_id']),
                    intval($data['bot_id']),
                    intval($data['user_id']),
                    $data['deal_status'],
                    $data['deal_started_at'],
                    $data['deal_close_at']
                ]
            );
        }
        echo json_encode(array(
            "status" => true,
            "data" => [],
            "message" => ""
        ));
    }
    if ($data['event_type'] === 'getUserHistory') {
        $len = 0;
        $limit_from = $data['limit_from'];
        $limit_to = $data['limit_to'];
        $user_id = $data["user_id"] === 0 ? '' : ' user_id=' . $data['user_id'] . ' ';
        $deal_id = $data["deal_id"] === 0 ? '' : ' deal_id=' . $data['deal_id'] . ' ';
        $state = $data["state"] === '' ? '' : ' deal_status="' . $data['state'] . '" ';
        $wh = '';

        if ($user_id != '') {
            $wh .= $user_id;
        }
        if ($state != '') {
            if ($wh != '') {
                $wh .= ',' . $state;
            } else {
                $wh .= $state;
            }
        }
        if ($deal_id != '') {
            if ($wh != '') {
                $wh .= ',' . $deal_id;
            } else {
                $wh .= $deal_id;
            }
        }

        $wh = str_replace(',', ' AND ', $wh);


        $history = $objData->getData('select * from user_history ' . ($wh != '' ? 'WHERE ' . $wh : '') . ' ORDER BY action_date DESC limit ' . $limit_from . ',' . $limit_to);
        $len = $objData->getData('select count(*) as len from user_history ' . ($wh != '' ? 'WHERE ' . $wh : ''));
        $len = $len[0]['len'];
        echo json_encode(array(
            "message" => "",
            "data" => array(
                "history" => $history,
                "len" => $len,
                "msg" => 'select * from user_history ' . ($wh != '' ? 'WHERE ' . $wh : '') . ' ORDER BY action_date DESC limit ' . $limit_from . ',' . $limit_to
            ),
            "status" => true
        ));
    }

    if ($data['event_type'] === 'getUserInfo') {
        $users = $objData->getData('SELECT * FROM scalpers_users WHERE user_id=' . $data['user_id']);
        $level = $objData->getData("SELECT * FROM scalpers_levels WHERE level_value=" . $users[0]['user_score']);
        echo json_encode(array(
            "message" => "",
            "data" => array(
                "user" => $users[0],
                "level" => $level
            ),
            "status" => true
        ));
    }

    if ($data['event_type'] === 'getUsersByName') {
        $users = $objData->getData('SELECT * FROM scalpers_users WHERE user_name LIKE "%' . $data['user_name'] . '%" OR user_id=' . intval($data['user_name']));
        echo json_encode(array(
            "message" => "",
            "data" => $users,
            "status" => true
        ));
    }

    if ($data['event_type'] === 'getDealsFinished') {
        $from = $data['from'];
        $to = $data['to'];
        $deals = $objData->getData('select * from scalpers_temp_deals,scalpers_users where scalpers_temp_deals.user_id=scalpers_users.user_id ORDER BY scalpers_temp_deals.deal_id DESC limit ' . $from . ',' . $to);
        $len = $objData->getData('select count(*) as len from scalpers_temp_deals,scalpers_users where scalpers_temp_deals.user_id=scalpers_users.user_id ORDER BY scalpers_temp_deals.deal_id');
        $len = $len[0]['len'];
        echo json_encode(array(
            "message" => "",
            "data" => array(
                'deals' => $deals,
                'len' => $len
            ),
            "status" => true
        ));
    }
    
    if ($data['event_type'] === 'getDealsFinishedByUserID') {
        $from = $data['from'];
        $to = $data['to'];
        $deals = $objData->getData('select * from scalpers_temp_deals,scalpers_users where scalpers_temp_deals.user_id=' . $data['user_id'] . ' and scalpers_users.user_id=' . $data['user_id'] . ' ORDER BY scalpers_temp_deals.deal_id DESC limit ' . $from . ',' . $to);
        $len = $objData->getData('select count(*) as len from scalpers_temp_deals,scalpers_users where scalpers_temp_deals.user_id=' . $data['user_id'] . ' and scalpers_users.user_id=' . $data['user_id'] . ' ORDER BY scalpers_temp_deals.deal_id');
        $len = $len[0]['len'];
        echo json_encode(array(
            "message" => "",
            "data" => array(
                'deals' => $deals,
                'len' => $len
            ),
            "status" => true
        ));
    }

    function searchStyle($id = 0, $column = "", $value)
    {
        // 1 = equal
        // 2 = start with
        // 3 = contains
        // 4 = end widht

        if ($value === '') return '';

        if ($id === 1) {
            return $column . "='" . $value . "'";
        }
        if ($id === 2) {
            return $column . " LIKE '%" . $value . "'";
        }
        if ($id === 3) {
            return $column . " LIKE '%" . $value . "%'";
        }
        if ($id === 4) {
            return $column . " LIKE '" . $value . "%'";
        }
    }

    if ($data['event_type'] === "SearchInBoots") {

        // bot name
        $bot_name = searchStyle(intval($data['bot_id']), 'bot_name', $data['bot_name']);

        // pair name
        $pair_name = searchStyle(intval($data['pair_id']), 'pair', $data['pair_name']);

        $result = [];
        $searchStatement = [];

        if ($data['api_id'] != '-1') {
            array_push($searchStatement, "api_id=" . $data['api_id']);
        }

        if ($data['boot_id'] != '') {
            array_push($searchStatement, "bot_id=" . $data['boot_id']);
        }

        if ($data['acc_id'] != '-1') {
            array_push($searchStatement, "account_id=" . $data['acc_id']);
        }
        
        if ($data['cat_id'] != '-2') {
            array_push($searchStatement, "cat_id=" . $data['cat_id']);
        }

        if ($data['status'] != '-3') {
            array_push($searchStatement, "user_id=" . $data['status']);
        }
        
        if ($data['user_id'] != '-1') {
            array_push($searchStatement, "user_id=" . $data['user_id']);
        }

        if ($bot_name !== '') {
            array_push($searchStatement, $bot_name);
        }
        if ($pair_name !== '') {
            array_push($searchStatement, $pair_name);
        }

        $statmentString = implode(" AND ", $searchStatement);

        if ($statmentString !== '') {
            $result = $objData->getData("SELECT * FROM scalpers_bots  WHERE " . $statmentString);
        }


        echo json_encode(array(
            "message" => "SELECT * FROM scalpers_bots  WHERE " . $statmentString,
            "data" => $result,
            "status" => true
        ));
    }

    if ($data['event_type'] === 'getUp24Deals') {
        $deals = $objData->getData("SELECT * FROM scalpers_up24 limit 0, 20");
        $len = $objData->getData("SELECT count(*) as len FROM scalpers_up24");
        $len = $len[0]['len'];
        echo json_encode(
            array(
                "data" => array(
                    "deals" => $deals,
                    "len" => $len
                ),
                "message" => "",
                "status" => false
            )
        );
    }
    if($data['event_type'] === 'getCategoryByName')
    {
        $cats = $objData->getData("SELECT * FROM scalpers_categories WHERE cat_is_group = 1 AND cat_name LIKE '%".$data['cat_name']."%'");
        echo json_encode(array(
            "message" => "",
            "data" => $cats,
            "status" => true
        ));
    }
} else {
    header("HTTP/1.1 404 Not Found");
}
